<?php
# Fonctions dcomposant le header
# Version V0.8 2004/10/28

function dec_preambule ($str , $verbose=0) {
return array(
	"name" => "Comment",
	"type" => substr($str,0,20),
	"short" => substr($str,20,16),
	"long" => substr($str,55,58)
);
}

function dec_chDefSetup ($str, $verbose=0) {
$smu = array();
for ($i=0; $i<6; $i++) {
	$smu = array_merge($smu,
		array( array(
			"Vname" => rtrim(substr($str,15+26*$i,6)),
			"Iname" => rtrim(substr($str,23+26*$i,6)),
			"mode" => chDefMode(substr($str,31+26*$i,2)),
			"fctn" => chDefFCTN(substr($str,33+26*$i,2))
			)));
}
return array(
	"name" => substr($str,0,10),
	"SMU" => $smu
);
}

function dec_uFncVarSet ($str , $verbose=0) {
return array(
	"name" => substr($str,0,10)
);
}

function dec_sweepSetup ($str , $verbose=0) {
return array(
       "name" => substr($str,0,10),
       "hold_time" => f64cvt(substr($str,11,8)),
       "delay_time" => f64cvt(substr($str,19,8)),
       "var1" => array(
       	      "min" => f64cvt(substr($str,37,8)),
	      "max" => f64cvt(substr($str,45,8)),
       	      "step" => f64cvt(substr($str,53,8)),
       	      "compliance" => f64cvt(substr($str,65,8)),
       ),
       "var2" => array(
       	      "min" => f64cvt(substr($str,85,8)),
	      "max" => f64cvt(substr($str,93,8)),
	      "step" => f64cvt(substr($str,101,8)),
	      "compliance" => f64cvt(substr($str,113,8))
       )
       );
}

function dec_constSetup ($str , $verbose=0) {
$tmp = array("name" => substr($str,0,10));
for ($i=1;$i<=6;$i++) {
	$tmp = array_merge($tmp, array("SMU" . $i => array(
		"source" => f64cvt(substr($str,11+16*($i-1),8)),
		"compliance" => f64cvt(substr($str,19+16*($i-1),8))
	)));
}
return $tmp;
}

function dec_meas_setup ($str , $verbose=0) {
return array(
	"name" => substr($str,0,10)
);
}

function dec_oSeqTrgSet ($str , $verbose=0) {
return array(
	"name" => substr($str,0,10)
);
}

function dec_analyssSet ($str , $verbose=0) {
return array(
	"name" => substr($str,0,10)
);
}

function dec_gDispSetup ($str , $verbose=0) {
$tmp = array(
       "name" => substr($str,0,10),
       "X" => array(
       	   "name" => rtrim(substr($str,13,8)),
	   "scale" => hexdec(bin2hex(substr($str,21,2))) & 0x1 ? "Log" : "Linear",
	   "min" => f64cvt(substr($str,23,8)),
	   "max" => f64cvt(substr($str,31,8))
       ),
       "Y1" => array(
       	    "name" => rtrim(substr($str,57,8)),
	    "scale" => hexdec(bin2hex(substr($str,65,2))) & 0x1 ? "Log" : "Linear",
	    "min" => f64cvt(substr($str,67,8)),
	    "max" => f64cvt(substr($str,75,8))
       ));
(substr($str,101,1)!=chr(0)) and $tmp = array_merge($tmp,array(
       "Y2" => array(
       	    "name" => rtrim(substr($str,101,8)),
	    "scale" => hexdec(bin2hex(substr($str,109,2))) & 0x1 ? "Log" : "Linear",
	    "min" => f64cvt(substr($str,111,8)),
	    "max" => f64cvt(substr($str,119,8))
       )));

$tmp = array_merge($tmp, array(
       "list" => array(
       	      rtrim(substr($str,145,8)),
              rtrim((substr($str,153,1)!=chr(0)) ? substr($str,153,8) : ''),
              rtrim((substr($str,161,1)!=chr(0)) ? substr($str,161,8) : ''),
              rtrim((substr($str,169,1)!=chr(0)) ? substr($str,169,8) : ''),
              rtrim((substr($str,177,1)!=chr(0)) ? substr($str,177,8) : ''),
	      rtrim((substr($str,185,1)!=chr(0)) ? substr($str,185,8) : ''),
	      rtrim((substr($str,193,1)!=chr(0)) ? substr($str,193,8) : ''),
	      rtrim((substr($str,201,1)!=chr(0)) ? substr($str,201,8) : '')
       ),
       "Data_Variables" => array(
       		rtrim(substr($str,209,8)),
		rtrim(substr($str,217,8))
       ),
       "grid" => hexdec(bin2hex(substr($str,245,2))) & 0x1,
       "line_parameter" => hexdec(bin2hex(substr($str,249,2))) & 0x1
));
return $tmp;
}

function dec_mini_header($str,$verbose=0) {
$apd = (strlen($str)==888);
$tmp = array("name" => "Setup Values");
for ($i=1;$i<=6;$i++) {
	$tmp = array_merge($tmp, array("SMU" . $i => array(
		"source" => f64cvt(substr($str,74+8*($i-1),8)),
		"compliance" => f64cvt(substr($str,282+8*($i-1),8))
	)));
}
$tmp = array_merge($tmp,array(
	"var1" => array(
		"min" => f64cvt(substr($str,606,8)),
		"max" => f64cvt(substr($str,614,8)),
		"step" => f64cvt(substr($str,622,8))),
	"var2" => array(
		"min" => f64cvt(substr($str,634,8)),
		"max" => f64cvt(substr($str,642,8)),
		"step" => f64cvt(substr($str,650,8)))));
return $tmp;
}



?>
