<?php
# Convert HP415x DAT files into TXT files
# Version 0.8 2004/10/28
# Functions file

function f64cvt($src, $verbose=0)
{
/* Float 64 bits description :
sgn (1bit) - exp (11bits) - mantissa (52bits)

Due to php resctiction on 32bits systems, manipulation of number larger than 32bits is not recommended
$src is split in 2 32bits numbers.
*/
$src1 = substr($src,0,4);
$src2 = hexdec(bin2hex(substr($src,4,4)));

$sgn = (hexdec(bin2hex($src1)) >> 31) & 0x1;
$exp = ((hexdec(bin2hex($src1)) >> 20) & 0x7FF) - 1023;
$mantissa1 = hexdec(bin2hex($src1)) & 0x000FFFFF;

$sum = 0.0;

for ($i=-52;$i<-20;$i++) {
	$value = $src2 & 1;
	$sum+= $value*pow(2,$exp+$i);
	$src2 = $src2 >> 1;
}
for ($i=-20;$i<0;$i++) {
	$value=$mantissa1 & 1;
	$sum+= $value*pow(2,$exp+$i);
	$mantissa1 = $mantissa1 >> 1;
}
$sum+=1*pow(2,$exp);

$sum = (abs($sum)<1E-300) ? 0 : $sum;

return ($sgn) ? -1*$sum : $sum;
}


function findNB($fp,$verbose='',$osd=false,$ver) {
$mark='';
$stats = fstat($fp);
fseek($fp, ((ftell($fp)+1)%2), SEEK_CUR);
$ok=0;
while ((!$ok) and (ftell($fp)<$stats['size'])) {
#Recherche de 'FFF0' ou 'FFEF'
$fff0 = 0;
while ((!$fff0) and (ftell($fp)<$stats['size'])) {
	$test = '';
	while ((ftell($fp)<$stats['size']) and ((((!$ver) and ($test!=chr(255).chr(240)))) or (($ver) and ($test!=chr(255).chr(239))))) {
		$test = fread($fp,2);
	}
	fseek($fp,6,SEEK_CUR);
	$test = fread($fp,2);
	$fff0 = (((!$ver) and($test==chr(127).chr(240))) or (($ver) and ($test==chr(127).chr(239))));
}
empty($verbose) or out($verbose,"Fin FFF0 0..0 7FF0 : ".ftell($fp).".\n",$osd);

fseek($fp,14,SEEK_CUR);

#Fin du bloc entier 0.(26).0 'FFF0' 0.(6).0 '7FF0' 0.(14).0  for HP4155/4156A
#Fin du bloc entier 0.(26).0 'FFEF' F.(6).F '7FEF' F.(6).F 0.(8).0  for Agilent 4156C

$bloc = 1;
while (($bloc) and (ftell($fp)<$stats['size'])) {
$pointer = ftell($fp);
fseek($fp,26,SEEK_CUR);
$test='';
$test = fread($fp,2);
if (((!$ver) and ($test!=chr(255).chr(240))) or (($ver) and ($test!=chr(255).chr(239)))) {
	$bloc=0;
	fseek($fp,$pointer,SEEK_SET);
} else {
	fseek($fp,6,SEEK_CUR);
	$test = fread($fp,2);
	if (((!$ver) and ($test!=chr(127).chr(240))) or (($ver) and ($test!=chr(127).chr(239)))) {
		$bloc=0;
		fseek($fp,$pointer,SEEK_SET);
	} else {
		fseek($fp,14,SEEK_CUR);
	}
}
}
empty($verbose) or out($verbose,"Fin Bloc : " . ftell($fp).".\n",$osd);
$pointer = ftell($fp);
# test if numbers start after :
fseek($fp,2+8,SEEK_CUR);
$mark=fread($fp,2);
fseek($fp,8,SEEK_CUR);
$test=fread($fp,2);
empty($verbose) or out($verbose,"Mark '$mark' - Test '$test'\n",$osd);
$ok = (($mark!=chr(0).chr(0)) and ($mark==$test));
fseek($fp,-22,SEEK_CUR);
}
return $mark;
}

function chDefMode($str) {
switch (substr($str,1,1)) {
	case chr(0) :
		return "V";
	case chr(2) :
		return "I";
	case chr(3) :
		return "VPulse";
	case chr(4) :
		return "IPulse";
	default :
		return "Common";
}
}

function chDefFCTN($str) {
switch (substr($str,1,1)) {
	case chr(2) :
		return "Var1";
	case chr(3) :
		return "Var2";
	case chr(4) :
		return "Var1'";
	default :
		return "Const";
}}

function findUnit($value, $smu) {
$unit = 'Unknown';
foreach($smu as $var) {
	($var['Vname']==$value) and $unit="V";
	($var['Iname']==$value) and $unit="A";
}
return $unit;
}

function out($fp,$value,$osd=false) {
	fwrite($fp,str_replace("\n","\n\r",$value)); //fprintf
	$osd and print($value);
}

function compare_head($sweepSetup,$constSetup,$chDefSetup,$mini) {
$tmp = '';
$exclude=array();
$vars=array();
for ($i=0;$i<6;$i++) {
	(trim($chDefSetup['SMU'][$i]['Vname'])=='') and $exclude=array_merge($exclude,array($i));
	($chDefSetup['SMU'][$i]['fctn']!="Const") and $vars=array_merge($vars,array(strtolower($chDefSetup['SMU'][$i]['fctn'])));
}
foreach($vars as $index) {
	foreach($sweepSetup[$index] as $key => $value) {
		if ($key=="compliance") continue;
		$tmp.=($mini[$index][$key]==$value) ? '' : "$index $key = " . $mini[$index][$key] . "\t";
	}
}

for ($i=1;$i<=6;$i++) {
	if (in_array($i-1,$exclude)) continue;
	foreach($constSetup['SMU'.$i] as $key => $value) {
		#$tmp.= ($mini['SMU'.$i][$key]==$value) ? '' : "SMU$i $key = " . $mini['SMU'.$i][$key] . "\t";
		$tmp.= ($mini['SMU'.$i][$key]==$value) ? '' : $chDefSetup['SMU'][$i-1][$chDefSetup['SMU'][$i-1]['mode']."name"] . " = " . $mini['SMU'.$i][$key] . " " . str_replace("I","A",$chDefSetup['SMU'][$i-1]['mode']) . "\t";
	}
}
return $tmp . "\n";
}
?>
